<?php
// Version: 2.3; PortalShoutbox

function template_shoutbox_all()
{
	global $context, $scripturl, $settings, $txt;

	echo '
	<div class="tborder">
		<table class="shoutbox_container">
			<tr>
				<td class="catbg shoutbox_padding">
					', $context['SPortal']['shoutbox']['name'], '
				</td>
			</tr>
			<tr class="windowbg smalltext">
				<td class="shoutbox_page_index">
					', $txt['pages'], ': ', $context['page_index'], '
				</td>
			</tr>
			<tr>
				<td class="windowbg shoutbox_body">
					<ul class="shoutbox_list_all" id="shouts">';

	if (!empty($context['SPortal']['shouts_history']))
		foreach ($context['SPortal']['shouts_history'] as $shout)
			echo '
						', !$shout['is_me'] ? '<li class="smalltext"><strong>' . $shout['author']['link'] . ':</strong></li>' : '', '
						<li class="smalltext">', $shout['text'], '</li>
						<li class="smalltext shoutbox_time">', $shout['delete_link'], $shout['time'], '</li>';
	else
			echo '
						<li class="smalltext">', $txt['sp_shoutbox_no_shout'], '</li>';

	echo '
					</ul>
				</td>
			</tr>
			<tr class="windowbg smalltext">
				<td class="shoutbox_page_index">
					', $txt['pages'], ': ', $context['page_index'], '
				</td>
			</tr>
		</table>
	</div>';
}

function template_shoutbox_embed($shoutbox)
{
	global $context, $scripturl, $settings, $txt;

	echo '
	<form action="" method="post">
		<table class="shoutbox_container">
			<tr class="windowbg smalltext">
				<td class="shoutbox_info" colspan="2">
					<div id="shoutbox_load_', $shoutbox['id'], '" style="float: right; display: none;"><img src="', $settings['sp_images_url'], '/loading.gif" alt="" /></div>
					<a href="', $scripturl, '?action=portal;sa=shoutbox;shoutbox_id=', $shoutbox['id'], '" onclick="sp_refresh_shout(', $shoutbox['id'], ', 0); return false;">', sp_embed_image('refresh'), '</a> <a href="', $scripturl, '?action=portal;sa=shoutbox;shoutbox_id=', $shoutbox['id'], '">', sp_embed_image('history'), '</a>';

	if ($context['can_shout'])
		echo ' <a href="#smiley" onclick="sp_collapse_object(\'sb_smiley_', $shoutbox['id'], '\', false); return false;">', sp_embed_image('smiley'), '</a> <a href="#style" onclick="sp_collapse_object(\'sb_style_', $shoutbox['id'], '\', false); return false;">', sp_embed_image('style'), '</a>';

	echo '
				</td>
			</tr>';

	if ($context['can_shout'])
	{
		echo '
			<tr class="windowbg smalltext" id="sp_object_sb_smiley_', $shoutbox['id'], '" style="display: none;">
				<td colspan="2">';

		foreach ($shoutbox['smileys'] as $smiley)
			echo '
					<a href="javascript:void(0);" onclick="replaceText(\' ', $smiley['code'], '\', document.getElementById(\'new_shout_', $shoutbox['id'], '\')); return false;"><img src="', $settings['smileys_url'], '/', $smiley['filename'], '" alt="', $smiley['description'], '" title="', $smiley['description'], '" /></a>';

		echo '
				</td>
			</tr>
			<tr class="windowbg smalltext" id="sp_object_sb_style_', $shoutbox['id'], '" style="display: none;">
				<td colspan="2">';

		foreach ($shoutbox['bbc'] as $image => $tag)
		{
			if (!in_array($tag['code'], $shoutbox['allowed_bbc']))
				continue;

			if (!isset($tag['after']))
				echo '<a href="javascript:void(0);" onclick="replaceText(\'', $tag['before'], '\', document.getElementById(\'new_shout_', $shoutbox['id'], '\')); return false;">';
			else
				echo '<a href="javascript:void(0);" onclick="surroundText(\'', $tag['before'], '\', \'', $tag['after'], '\', document.getElementById(\'new_shout_', $shoutbox['id'], '\')); return false;">';

			echo '<img onmouseover="style_highlight(this, true);" onmouseout="if (window.style_highlight) style_highlight(this, false);" src="', $settings['images_url'], '/bbc/', $image, '.gif" align="bottom" width="23" height="22" alt="', $tag['description'], '" title="', $tag['description'], '" style="background-image: url(', $settings['images_url'], '/bbc/bbc_bg.gif); margin: 1px 2px 1px 1px;" /></a>';
		}

		echo '
				</td>
			</tr>';
	}

	echo '
			<tr>
				<td class="windowbg shoutbox_body" colspan="2">
					<ul class="shoutbox_list_compact" id="shouts_', $shoutbox['id'], '">';

	if (!empty($shoutbox['warning']))
		echo '
						<li class="shoutbox_warning smalltext">', $shoutbox['warning'], '</li>';

	if (!empty($shoutbox['shouts']))
		foreach ($shoutbox['shouts'] as $shout)
			echo '
						<li class="smalltext">', !$shout['is_me'] ? '<strong>' . $shout['author']['link'] . ':</strong> ' : '', $shout['text'], '<br />', !empty($shout['delete_link_js']) ? '<span class="shoutbox_delete">' . $shout['delete_link_js'] . '</span>' : '' , '<span class="smalltext shoutbox_time">', $shout['time'], '</span></li>';
	else
			echo '
						<li class="smalltext">', $txt['sp_shoutbox_no_shout'], '</li>';

	echo '
					</ul>
				</td>
			</tr>';

	if ($context['can_shout'])
		echo '
			<tr class="windowbg smalltext">
				<td class="shoutbox_input">
					<input type="text" name="new_shout" id="new_shout_', $shoutbox['id'], '" class="shoutbox_input" />
				</td>
				<td>
					<input type="submit" name="submit_shout" value="', $txt['sp_shoutbox_button'], '" onclick="sp_submit_shout(', $shoutbox['id'], ', \'', $context['session_var'], '\', \'', $context['session_id'], '\'); return false;" />
				</td>
			</tr>';

	echo '
		</table>
		<input type="hidden" name="shoutbox_id" value="', $shoutbox['id'], '" />
		<input type="hidden" name="', $context['session_var'], '" value="', $context['session_id'], '" />
	</form>';

	if (!empty($shoutbox['refresh']))
		echo '
	<script language="Javascript" type="text/javascript"><!-- // --><![CDATA[
		var interval_id_', $shoutbox['id'], ' = setInterval( "sp_auto_refresh_', $shoutbox['id'], '()", ', $shoutbox['refresh'], ' * 1000);
		var last_refresh_', $shoutbox['id'], ' = ', time(), ';
		function sp_auto_refresh_', $shoutbox['id'], '()
		{
			if (window.XMLHttpRequest)
			{
				sp_refresh_shout(', $shoutbox['id'], ', last_refresh_', $shoutbox['id'], ');
				last_refresh_', $shoutbox['id'], ' += ', $shoutbox['refresh'], ';
			}
			else
				clearInterval(interval_id_', $shoutbox['id'], ');
		}
	// ]]></script>';
}

function template_shoutbox_xml()
{
	global $context, $txt;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<smf>
	<shoutbox>', $context['SPortal']['shoutbox']['id'], '</shoutbox>';

	if ($context['SPortal']['updated'])
	{
		echo '
	<updated>1</updated>
	<error>', empty($context['SPortal']['shouts']) ? $txt['sp_shoutbox_no_shout'] : 0, '</error>
	<warning>', !empty($context['SPortal']['shoutbox']['warning']) ? htmlspecialchars($context['SPortal']['shoutbox']['warning']) : 0, '</warning>';

	foreach ($context['SPortal']['shouts'] as $shout)
		echo '
	<shout>
		<id>', $shout['id'], '</id>
		<author>', htmlspecialchars($shout['author']['link']), '</author>
		<time>', htmlspecialchars($shout['time']), '</time>
		<timeclean>', strip_tags($shout['time']), '</timeclean>
		<delete>', !empty($shout['delete_link_js']) ? htmlspecialchars($shout['delete_link_js']) : 0, '</delete>
		<body>', htmlspecialchars($shout['text']), '</body>
		<is_me>', $shout['is_me'] ? 1 : 0, '</is_me>
	</shout>';
	}
	else
		echo '
	<updated>0</updated>';

	echo '
</smf>';
}

?>